import mysql.connector
import requests
import base64
import time
import urllib3

# Desativa os avisos de verificação de certificado
urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)

class DownloadImagem:
    def __init__(self):
        self.db_host = "187.45.179.18"
        self.db_user = "colibexcom_user"
        self.db_pass = "wo3dZ}@*eS$%"
        self.db_name = "colibexcom_banco"
        self.conn = self.connect_db()

    def connect_db(self):
        return mysql.connector.connect(
            host=self.db_host,
            user=self.db_user,
            password=self.db_pass,
            database=self.db_name
        )

    def sqlC(self, query):
        cursor = self.conn.cursor(dictionary=True)
        cursor.execute(query)
        result = cursor.fetchall()
        cursor.close()
        return result

    def update_img(self, base64_image, img_id):
        cursor = self.conn.cursor()
        update_query = "UPDATE `z_fotos_imoveis_caixa` SET `img` = %s WHERE id = %s;"
        cursor.execute(update_query, (base64_image, img_id))
        self.conn.commit()
        cursor.close()

    def imoveis(self):
        sql = self.sqlC("SELECT id, foto FROM `z_fotos_imoveis_caixa` WHERE `img` IS NULL ORDER BY `id` DESC LIMIT 1000000;")
        
        for value in sql:
            print(value['foto'])
            try:
                response = requests.get(value['foto'], headers={'User-Agent': 'Googlebot-Image/1.0'}, verify=False, cookies={})
                response.raise_for_status()
            except requests.RequestException as e:
                print(f"Erro: {e}")
                continue

            if response.content:
                base64_image = base64.b64encode(response.content).decode('utf-8')
                self.update_img(base64_image, value['id'])
                print(value['id'])
            else:
                print('Erro ao baixar a imagem.')
            
            time.sleep(1)

        self.conn.close()

if __name__ == "__main__":
    downloader = DownloadImagem()
    downloader.imoveis()